/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <gtc/gtc_particle.h>

#include <hpx/runtime/hpx_thread_manager.h>
#include <iostream>
#include <fstream>

namespace hpx_gtc
{

  using namespace sstmac;
  using namespace sstmac::sw;
  using namespace hpx;


  std::string gtc_app::gtc_particle::particlefile_ = "";

  /// Initialize the accumulator
  void
  gtc_app::gtc_particle::init(std::size_t objectid, double posx, double posy,
      double posz)
  {
    idx_ = objectid;

    posx_ = posx;
    posy_ = posy;
    posz_ = posz;

    SSTMAC_DEBUG << "gtc_particle: particle " << objectid << " is (" << posx
          << ", " << posy << ", " << posz << ") \n";
  }

  double
  gtc_app::gtc_particle::distance(double posx, double posy, double posz)
  {
    return sqrt(
        pow(posx_ - posx, 2) + pow(posy_ - posy, 2) + pow(posz_ - posz, 2));
  }

  void
  gtc_app::gtc_particle::register_actions(
      boost::intrusive_ptr<hpx::hpx_thread_manager> threadman)
  {
    /*threadman->register_action<init_action>(init_action::get_action_name(),
     init_action::construct());
     threadman->register_action<distance_action>(distance_action::get_action_name(),
     distance_action::construct());*/

  }

}
