/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_SKELETONS_PARALLEX_HPX_RMA_ELEMENT_STUBS_H_INCLUDED
#define SSTMAC_SOFTWARE_SKELETONS_PARALLEX_HPX_RMA_ELEMENT_STUBS_H_INCLUDED

#include <rma/hpx_rma_element.h>
#include <hpx/components/hpx_stubs.h>
#include <hpx/lcos/promise.h>

namespace hpx
{
  namespace rma
  {

    class hpx_random_mem_access::hpx_rma_element::rma_stubs : public hpx::components::hpx_stubs
    {

    protected:
      rma_stubs(hpx::globalid gid) :
          hpx_stubs(gid)
      {

      }

    public:
      typedef boost::intrusive_ptr<rma_stubs> ptr;

      static ptr
      construct(hpx::globalid gid)
      {
        return ptr(new rma_stubs(gid));
      }

      virtual
      ~rma_stubs() { }

      void
      init(std::size_t s);

      void
      add();

      void
      print();

      hpx::lcos::promise<int>::ptr
      add_async();

      hpx::lcos::promise<int>::ptr
      print_async();
    };


} }

#endif
