      program test
      implicit none

#include "mafdecls.fh"
#include "global.fh"
c#include "mpif.h"

      integer g_dens, g_ident
      integer two, dims(2), bcdims(2), proc_grid(2)
      logical status
      integer heap, stack
      
      integer ierr
      call mpi_init(ierr)
      call ga_initialize()

      call ga_sync
      
      heap =  32000000
      stack = 32000000
      if (.not.ma_init(MT_DBL, stack, heap))
     +   call ga_error("ma_init failed",-1)
      flush(6)

      two = 2
      dims(1) = 2000
      dims(2) = 2000
      bcdims(1) = 40
      bcdims(2) = 40

      g_ident = ga_create_handle()
      call ga_set_data(g_ident, two, dims, MT_DBL)
      status = ga_allocate(g_ident)
      call ga_zero(g_ident)

      call ga_nblock(g_ident, proc_grid)
 
      g_dens = ga_create_handle()
      call ga_set_data(g_dens, two, dims, MT_DBL)
#if 1
      call ga_set_block_cyclic_proc_grid(g_dens, bcdims, proc_grid)
#endif
      status = ga_allocate(g_dens)
      call ga_zero(g_dens)

      call ga_terminate
      call mpi_finalize

      end
      
