/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_FLOW_FLOWRACKSWITCH_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_FLOW_FLOWRACKSWITCH_H_INCLUDED

#include <map>
#include <networkmodels/rackswitch.h>

namespace sstmac { namespace omnetpp {

#define ROUTER_DELAY 0.0000001
  //#define ROUTER_DELAY 0

  class flowrackswitch : public rackswitch
  {

  protected:

    virtual void
    handleMessage(cMessage* cmg);
    virtual void
    initialize();
    virtual void
    finish();

    void
    recalculateBandwidths(int port);

    //map<int, cGate*> inports;
    std::map<int, cGate*> outports;

    // things tracked per flow
    std::map<std::pair<int, int> , double> flowBW;
    std::map<std::pair<int, int> , simtime_t> flowStart;
    std::map<std::pair<int, int> , double> flowSrcBW;

    //things tracked per outport
    std::map<int, double> requestedBW;
    std::map<int, simtime_t> lastUpdate;
    std::map<int, std::set<std::pair<int, int> >*> flows;

    double networkFlowBW;

    bool display_connections_;
  };
} }
#endif
