/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_ROUTING_dragonflyROUTER_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_ROUTING_dragonflyROUTER_H_INCLUDED

#include <networkmodels/routing/router.h>

namespace sstmac { namespace omnetpp {


  class dragonflyrouter: public router {
  public:
    dragonflyrouter(omnetpp_address::ptr m, int npr, int g, int r, int n) :
      router(m, npr), group_(g), rack_(r), num_groups_(n) {

      myX_ = rack_ % 16;
      myY_ = rack_ / 16;
      SSTMAC_DEBUG << "router rack id = " << me->rack() << "; group = " << group_ << ", rack= " << rack_ << "\n";
    }

    virtual int route(NetworkMsg* msg, omnetpp_address::ptr to, int inport, bool &dim_change);

  protected:
    int group_;
    int rack_;
    int num_groups_;

    int myX_;
    int myY_;

  };

} }
#endif
