/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_ROUTING_ROUTER_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NETWORKMODELS_ROUTING_ROUTER_H_INCLUDED

#include <omnetppaddress.h>

#include <sstmac/common/debug.h>

#include <sstmac/backends/omnetpp/network_m.h>

namespace sstmac { namespace omnetpp {


  class router {
  public:
    router(omnetpp_address::ptr m, int npr) :
      dbg_("<debug> router | network") {
      me = m;
      nodesPerRack = npr;

    }

    virtual ~router() {}

    virtual int route(NetworkMsg* msg, omnetpp_address::ptr to, int inport, bool &dim_change) = 0;

  protected:
    omnetpp_address::ptr me;

    int nodesPerRack;

    sstmac::debug dbg_;
  };

} }
#endif
