/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/backends/omnetpp/node/nic/nic.h>

#include <sstmac/common/ptr_type.h>
#include <sstmac/common/messages/sst_message.h>


namespace sstmac { namespace omnetpp {

  debug nic::dbg_;

  void
  nic::send_proc_ack(ApplicationMsg* appMsg, cGate* toProc)
  {
    SSTMAC_DEBUG<< "NIC: ack'ing a send " << appMsg->getMsgcontent().load->to_string()
              << "\n ";

    appMsg->setByteLength(0);
    sst_message::ptr sstm = appMsg->getMsgcontent().load->clone(sst_message::SEND_ACK);
    payloadpod ppod(sstm);
    appMsg->setMsgcontent(ppod);
    CoreMsg* ack = new CoreMsg();
    ack->setMsgType(NIC_SEND_ACK);
    ack->setToAddr(appMsg->getFromAddr());
    ack->encapsulate(appMsg);
    ack->setByteLength(NIC_ACK_SIZE);

    send(ack, toProc);
  }

} }
