/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_NIC_NIC_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_NIC_NIC_H_INCLUDED

#include <omnetpp.h>

#include <sstmac/common/debug.h>

#include <sstmac/backends/omnetpp/node_m.h>

#define NIC_ACK_SIZE 8

namespace sstmac { namespace omnetpp {


  class nic : public cSimpleModule
  {
  public:
	  nic()
    {
      if(!dbg_.is_real()){
           dbg_ = debug("<debug> nic");
           logger::register_logger(&dbg_);
       }
    }

	 virtual ~nic(){}

  protected:
    virtual void
    send_proc_ack(ApplicationMsg* appMsg, cGate* toProc);

    static sstmac::debug dbg_;
  };
} }
#endif
