/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_ENVIRONMENTPOD_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_ENVIRONMENTPOD_H_INCLUDED

#include <omnetpp.h>
#include <sstmac/software/ami/environment.h>

#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace omnetpp {


  class environmentpod
  {
  public:
    sstmac::sw::environment::ptr load;

    environmentpod() : load()
    {

    }

    environmentpod(sstmac::sw::environment::ptr l) :
      load(l)
    {
    }
    ;
    virtual
    ~environmentpod();

    environmentpod*
    copy()
    {
      return new environmentpod(load);
    }
  };

  void
  doPacking(cCommBuffer *buffer, environmentpod& load);
  void
  doUnpacking(cCommBuffer *buffer, environmentpod& load);

} }
#endif
