/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_EVENTHANDLERPOD_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_EVENTHANDLERPOD_H_INCLUDED

#include <omnetpp.h>
#include <sstmac/common/eventhandler.h>

#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace omnetpp {


  class eventhandlerpod
  {
  public:
    sstmac::eventhandler::ptr load;

    eventhandlerpod() :
      load()
    {

    }
    eventhandlerpod( sstmac::eventhandler::ptr l) :
      load(l)
    {
    }
    ;
    virtual
    ~eventhandlerpod();


  };

  void
  doPacking(cCommBuffer *buffer, eventhandlerpod& load);

  void
  doUnpacking(cCommBuffer *buffer, eventhandlerpod& load);

} }
#endif
