/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "dummynocmodel.h"

namespace sstmac { namespace omnetpp {


  Define_Module(dummynocmodel)
    ;

  dummynocmodel::dummynocmodel() {


  }

  dummynocmodel::~dummynocmodel() {

  }

  void dummynocmodel::initialize() {
    /*int numCores = par("numOfCores");
        for (int i = 0; i < numCores; i++) {
                fromProc[i] = gate("toCores$i", i);
                toProc[i] = gate("toCores$o", i);
        }

        int numNetPorts = par("numNetworkPorts");
        for (int i = 0; i < numNetPorts; i++) {
                fromNetwork[i] = gate("toExternalNetwork$i", i);
                toNetwork[i] = gate("toExternalNetwork$o", i);
        }

        int numStor = par("numStoragePorts");
        for (int i = 0; i < numStor; i++) {
                fromStorage[i] = gate("toStorage$i", i);
                toStorage[i] = gate("toStorage$o", i);
        }*/

    fromProc[0] = gate("toCore$i");
    toProc[0] = gate("toCore$o");

    fromNetwork[0] = gate("toNetwork$i");
    toNetwork[0] = gate("toNetwork$o");


    nocDelay = 1e-8;

  }

  void dummynocmodel::handleMessage(cMessage* cmsg) {
    cGate* arrival = cmsg->getArrivalGate();
    //std::cout << "NOC: got message" << endl;
    map<int, cGate*>::iterator it;

    for (it = fromProc.begin(); it != fromProc.end(); it++) {
        if (it->second == arrival) {
            sendDelayed(cmsg, nocDelay, toNetwork[0]);
        }
    }

    for (it = fromNetwork.begin(); it != fromNetwork.end(); it++) {
        if (it->second == arrival) {
            sendDelayed(cmsg, nocDelay, toProc[0]);
        }
    }
  }

} }
