/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_PAYLOADPOD_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_PAYLOADPOD_H_INCLUDED

#include <omnetpp.h>
#include <sstmac/common/messages/sst_message.h>

#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace omnetpp {


  class payloadpod
  {
  public:
    sstmac::sst_message::ptr load;

    payloadpod() :
      load()
    {

    }
    payloadpod( sstmac::sst_message::ptr l) :
      load(l)
    {
    }
    ;
    virtual
    ~payloadpod();

    payloadpod*
    copy()
    {
      if (!load)
        {
          return new payloadpod();
        }
      else
        return new payloadpod(load->clone());
    }
  };

  void
  doPacking(cCommBuffer *buffer, payloadpod& load);
  void
  doUnpacking(cCommBuffer *buffer, payloadpod& load);

} }
#endif
