/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_COMMON_SIZEABLE_H_INCLUDED
#define SSTMAC_COMMON_SIZEABLE_H_INCLUDED

#include <sstmac/common/ptr_type.h>

namespace sstmac {

  class sizeable : public virtual ptr_type {
  public:
    typedef boost::intrusive_ptr<sizeable> ptr;

    virtual long
    get_byte_length() const = 0;

    virtual std::string
    to_string() const {
      return "sizeable";
    }


    virtual ~sizeable() { }
  };

}

#endif
