/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SIMPLE_MEMORYMODEL_H_
#define SIMPLE_MEMORYMODEL_H_

#include <sstmac/hardware/memory/memorymodel.h>



namespace sstmac { namespace hw
{

  class simple_memorymodel : public memorymodel
  {
  protected:
    simple_memorymodel(double mem_bw, timestamp mem_lat, eventhandler::ptr whendone, long nodeid);

    link::ptr link_;
    simple_memorymodel::ptr self_;
    eventhandler::ptr done_;

  public:
    typedef boost::intrusive_ptr<simple_memorymodel> ptr;

    static ptr
    construct(double mem_bw, timestamp mem_lat, eventhandler::ptr whendone, long nodeid){
      return ptr(new simple_memorymodel(mem_bw, mem_lat, whendone, nodeid));
    }

    virtual
    ~simple_memorymodel();

    virtual void handle(const sst_message::ptr &msg);

    virtual void do_access(sst_message::ptr msg);
  };

} } /* namespace sstmac */
#endif /* SIMPLE_MEMORYMODEL_H_ */
