/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/hpx/agas/agas_server.h>
#include <sstmac/software/libraries/hpx/parcels/resolve_gid.h>
#include <sstmac/software/libraries/hpx/parcels/resolve_gid_response.h>
//#include <hpx/parcels/new_gid.h>
#include <sstmac/common/errors.h>

namespace hpx
{

  sstmac::debug agas_server::dbg_;

  void
  agas_server::handle(const sstmac::sst_message::ptr &msg)
  {

   /* if (msg)
      {
        if (msg->get_type() == sstmac::sst_message::COMPUTE)
          {
            service_one();

            computing_--;
            if (pending_.size() > 0 && computing_ < MAX_OPS)
              {
                lib_mem_->compute_block_access(OP_SIZE);
                computing_++;
              }
          }
        else if (msg->get_type() == sstmac::sst_message::SEND_ACK)
          {
            return;
          }
        else
          {
            hpx::parcels::parcel::ptr par = boost::dynamic_pointer_cast<
                hpx::parcels::parcel>(msg);

            if (!par)
              {
                throw sstmac::ssterror(
                    "hpx::agas_server -- could not cast message to parcel");
              }

            pending_.push(par);
            if (computing_ < MAX_OPS)
              {
                lib_mem_->compute_block_access(OP_SIZE);
                computing_++;
              }
          }

      }*/
  }

 /* void
  agas_server::service_one()
  {
    if (pending_.size() > 0)
      {
        hpx::parcels::parcel::ptr par = pending_.front();
        pending_.pop();

        switch (par->type())
        {
        case hpx::parcels::parcel::RESOLVE_GID:
          {
            SSTMAC_DEBUG << "hpx::agas_server(" << locality_->to_string()
                    << "): servicing resolve_gid \n";
            hpx::parcels::resolve_gid::ptr ngp = boost::dynamic_pointer_cast<
                hpx::parcels::resolve_gid>(par);
            if (lvamap_.find(ngp->gid().gid_) == lvamap_.end())
              {
                throw sstmac::ssterror(
                    "hpx::agas_server::service_one() -- resolve-gid - can't find gid in lva map");
              }

            hpx::parcels::resolve_gid_response::ptr resp =
                hpx::parcels::resolve_gid_response::construct(ngp->gid(),
                    locality_, ngp->wait_id(), os_->now());
            resp->set_lib_name(libname_);
            resp->toaddr_ = ngp->origin();
            os_->execute_kernel(sstmac::sw::AMI::AMI_COMM,
                sstmac::sw::AMI::AMI_COMM_SEND, resp);
            break;
          }

        case hpx::parcels::parcel::RESOLVE_GID_RESPONSE:
          {
            SSTMAC_DEBUG << "hpx::agas_server(" << locality_->to_string()
                  << "): servicing resolve_gid_response \n";
            hpx::parcels::resolve_gid_response::ptr ngp =
                boost::dynamic_pointer_cast<hpx::parcels::resolve_gid_response>(
                    par);
            if (waiting_.find(ngp->wait_id()) == waiting_.end())
              {
                std::cout << "wait id: " << ngp->wait_id() << "\n";
                throw sstmac::ssterror(
                    "hpx::agas_server::service_one() - resolve_gid_response -- couldn't find waiter in map");
              }

            rx_ = par;
            os_->unblock(waiting_[ngp->wait_id()]);

            break;
          }

        default:
          throw sstmac::ssterror("hpx::agas_server -- unknown parcel type");

        }
      }
  }*/

  globalid
  agas_server::new_gid(lva::ENTITY_TYPE t)
  {
    globalid gid(gid_count_++);
    lva l(gid, locality_, t);
    lvamap_[gid.gid_] = l;
    return gid;
  }

  sstmac::nodeaddress::ptr
  agas_server::resolve_locality(const globalid &gid)
  {
    if (lvamap_.find(gid.gid_) != lvamap_.end())
      {
        return lvamap_[gid.gid_].addr();
      }
    else
      {
        //it's not here, so send it to it's home base

        sstmac::nodeaddress::ptr addr = sstmac::nodeaddress::convert_from_uniqueid(
            gid.get_node_uid());
        /*long waiting = WAITING_ID++;
        hpx::parcels::resolve_gid::ptr msg = hpx::parcels::resolve_gid::construct(
            gid, locality_, waiting, os_->now());
        msg->toaddr_ = addr;
        msg->set_lib_name(libname_); // send to my peer on the other side
        os_->execute_kernel(sstmac::sw::AMI::AMI_COMM,
            sstmac::sw::AMI::AMI_COMM_SEND, msg);
        sstmac::sw::key::ptr wait = sstmac::sw::key::construct();

        SSTMAC_DEBUG << "hpx::agas_server(" << locality_->to_string()
            << "): waiting with id " << waiting << "\n";
        waiting_[waiting] = wait;
        os_->block(wait);

        //when we're here, we've been unblocked by the response
        hpx::parcels::resolve_gid_response::ptr ngp = boost::dynamic_pointer_cast<
            hpx::parcels::resolve_gid_response>(rx_);
        waiting_.erase(waiting);
        return ngp->where();*/
        return addr;
      }
  }

}
