/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <hpx/components/hpx_distributing_factory.h>
#include <hpx/runtime/hpx_thread_manager.h>

namespace hpx
{
  namespace components
  {


    typedef hpx::actions::plain_result_action1<unsigned long long, // result type
           std::string, // argument
           create_component // function
       > create_component_action;


    void
    hpx_distributing_factory::register_actions(boost::intrusive_ptr<hpx_thread_manager> threadman)
    {
      threadman->register_action<create_component_action>(create_action_name(), create_component_action::construct());
    }


    hpx_distributing_factory::ef_type::ptr
    hpx_distributing_factory::get_ef(sstmac::nodeaddress::ptr addr, hpx_action_params::ptr params){
      return ef_type::construct(create_action_name(), addr, params);
    }

  } /* namespace hpx */
}
