/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/hpx/components/hpx_distributing_factory.h>
#include <hpx/runtime/hpx_thread_manager.h>

namespace hpx
{
  namespace components
  {

    unsigned long long
    create_component(std::string name)
    {

      hpx_thread_manager::ptr threadman = hpx_app::get_current_thread_manager();

      return threadman->create_component(name).gid_;
    }

  }

}

