/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_LCO_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_LCO_H_INCLUDED

#include <sstmac/common/debug.h>
#include <sstmac/software/process/key.h>
#include <sstmac/common/ptr_type.h>
#include <sstmac/software/process/os_api.h>


namespace hpx
{
  namespace lcos
  {

    class lco : public sstmac::ptr_type
    {

    protected:
      static sstmac::debug dbg_;
     // sstmac::sw::OS_API::ptr os_;

      lco();

     // lco(sstmac::sw::OS_API::ptr os);

    public:
      typedef boost::intrusive_ptr<lco> ptr;

      virtual std::string
      to_string() const {
        return "ptr_type";
      }

      virtual
      ~lco() { }
    };
  }
}

#endif
