/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMID_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMID_H_INCLUDED

#include <iosfwd>

namespace sstmac { namespace sw {

  /// Index assigned to a communicator.
  struct mpicommid {
    int id;
    explicit mpicommid(int idit);

    std::string to_string() const;
  };

  bool operator==(const mpicommid &a, const mpicommid &b);
  bool operator!=(const mpicommid &a, const mpicommid &b);
  bool operator<(const mpicommid &a, const mpicommid &b);
  bool operator>(const mpicommid &a, const mpicommid &b);
  bool operator<=(const mpicommid &a, const mpicommid &b);
  bool operator>=(const mpicommid &a, const mpicommid &b);

  std::ostream& operator<<(std::ostream &os, const mpicommid &id);

} } // end of namespace sstmac

#endif
