/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_STRATEGIES_MPI_COLLECTIVE_ENGINES_MPISCANENGINE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_STRATEGIES_MPI_COLLECTIVE_ENGINES_MPISCANENGINE_H_INCLUDED

#include <sstmac/software/libraries/mpi/mpi_strategies/mpi_collective/mpicollective.h>
#include <sstmac/software/libraries/mpi/mpi_types/mpitype.h>
#include <sstmac/software/libraries/mpi/mpi_types/mpitag.h>
#include <sstmac/software/libraries/mpi/mpi_comm/mpicomm.h>
#include <sstmac/software/libraries/mpi/mpi_types/mpiop.h>

namespace sstmac { namespace sw {

  /// Important types.
  class mpiqueue;
  class mpistatus;
  class nodeinterface;
  class topologyiterator;

  /**
   * An mpikernel to performs an mpi_scan
   */

  /*
  class mpiscanengine : public mpicollective {
    /// The iterator to whom we entrust our communication patterns.
    topologyiterator::ptr iter_;
    /// The lenght of our data array.
    int count_;
    /// The type we are sending and receiving.
    mpitype type_;
    /// The operation we are applying to our data.
    mpiop op_;
    /// The tag associated with this communication.
    mpitag tag_;
    /// My communicator.
    mpicomm comm_;
    /// The data we are collecting.
    mpicollpayload::const_ptr content_;

    /// The number of pending sends.
    int pending_sends_;
    /// The number of pending receives.
    int pending_recvs_;

    /// Fire off the next set of send and receive operations.
    void sendrecv(const timestamp &now);

    /// Private method used by the completer to indicate that our work is done
    void completer_done(const timestamp &now,
                        const mpicollpayload::const_ptr& content);

  protected:
    /// Hi.
    mpiscanengine(const topologyiterator::ptr& iter,
                  const mpirequest::ptr& thekey,
                  const mpiqueue::ptr& queue,
                  int count, const mpitype &type, 
                  const mpiop &op,
                  const mpitag &tag, const mpicomm &comm,
                  const payload::const_ptr& content,
                  eventhandler::ptr completion);

    /// Callback method to indicate that a send operation has completed.
    virtual void send_complete(
                               int count,
                               const mpitype &type,
                               const mpitag &tag,
                               const mpiid &dest);

    /// Callback method to indicate that a receive operation has completed.
    virtual void recv_complete(
                               int count,
                               const mpistatus::const_ptr& stat);

    /// Callback to to signal copy completion.
    void copy_complete(
                       int count,
                       const mpitype &type,
                       const mpitag &tag,
                       const mpiid &source);

  public:
    /// Make a new engine.
    static boost::shared_ptr<mpiscanengine>
    construct(const topologyiterator::ptr& iter,
              const mpirequest::ptr& thekey,
              const mpiqueue::ptr& queue,
              int count, const mpitype &type, 
              const mpiop &op, const mpitag &tag, const mpicomm &comm,
              const payload::const_ptr& content,
              eventhandler::ptr completion);

    /// Goodbye.
    virtual ~mpiscanengine() throw();

    /// Capture the 'start' method so we can set up our reducer.
    virtual void start();

  };
*/
} } // end of namespace sstmac

#endif
