/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/mpi/user_mpiapp_cxx.h>

int user_skeleton_main(int argc, char **argv);
void consume_parameters(const sstmac::sim_parameters::ptr &params);

namespace sstmac
{
  namespace sw
  {

    void user_mpiapp_cxx::skeleton_main() {
      user_skeleton_main(NULL,NULL);
    }

    void user_mpiapp_cxx::consume_params(
        const sstmac::sim_parameters::ptr &params) {
      consume_parameters(params);
    }

  } //end namespace sw
} //end namespace sstmac



