subroutine user_skeleton_main()
!use mpi
  include "sstmac/software/libraries/mpi/sstmac_mpi_f.h"
  integer ierr, message_size, me, nproc, tag, dst, src, stat(MPI_STATUS_SIZE),&
	world, fake_buf

  msg_size = 1
  tag = 0
  dst = 1
  src = 0

  call MPI_INIT(ierr)

  !This is one main difference, world comm has to be a function
  call MPI_Comm_World(world)
  call MPI_Comm_rank(world,me,ierr)
  call MPI_Comm_size(world,nproc,ierr)

  if (me == 0 .and. nproc /= 2) then
      write (*,*) 'sendrecv should only be run with two processors'
      call MPI_ABORT(world, 1, ierr)
  endif

  if (me == 0) then
      call MPI_Send(fake_buf, msg_size, MPI_INTEGER, dst, tag, world, ierr)
      write (*,*) 'rank ',me,' sending a message'
  else
      call MPI_Recv(fake_buf, msg_size, MPI_INTEGER, src, tag, world, stat, ierr)
      write (*,*) 'rank ',me,' receiving a message'
  endif

  call MPI_FINALIZE(ierr)
end
