/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMACRO_THE_SSTMACRO_H
#define SSTMACRO_THE_SSTMACRO_H

#include <sstmac/software/process/appdescr.h>
#include <sstmac/software/services/servdescr.h>

#include <sstmac/software/libraries/mpi/sstmac_mpi.h>
#include <sstmac/software/libraries/mpi/mpiapp.h>
#include <sstmac/software/libraries/mpi/mpiapi.h>
#include <sstmac/software/libraries/mpi/mpi_types/mpitype.h>

#include <sstmac/common/sim_parameters.h>
#include <sstmac/common/errors.h>
#include <sstmac/common/debug.h>
#include <sstmac/common/messages/eventdata.h>

/** Automatically inherit basic pointer types */
using sstmac::ptr_type;

/** Automatically inherit runtime types */
using sstmac::sim_parameters;
using sstmac::timestamp;
using sstmac::sw::softwareid;
using sstmac::sw::taskid;

/** Automatically inherit mpi tpes */
using sstmac::sw::mpitype;
using sstmac::sw::mpiid;
using sstmac::sw::mpiop;
using sstmac::sw::mpitag;
using sstmac::sw::mpicomm;
using sstmac::sw::mpirequest_t;
using sstmac::sw::const_mpistatus_t;
using sstmac::sw::mpistatus;
using sstmac::sw::mpiapi;
using sstmac::sw::mpiapp;

/** Automatically inherit the errors */
using sstmac::illformederror;
using sstmac::inputerror;
using sstmac::invalidkeyerror;
using sstmac::ioerror;
using sstmac::iteratorerror;
using sstmac::libraryerror;
using sstmac::memoryerror;
using sstmac::nullerror;
using sstmac::oserror;
using sstmac::rangeerror;
using sstmac::ssterror;


#endif

