
#include "sdma_disk_lib.h"
#include "sdma_message.h"
#include "sdma_disk_server.h"

using namespace sstmac;
using namespace sstmac::sw;

namespace sdma
{

  void
  sdma_disk_lib::process_data(long bytes)
  {
    if(!file_){
        file_ = pfs_->create(("temp-sdma-"+id_.to_string()));
    }

    pfs_->write(file_, bytes, true);

    sdma_go_disk::ptr mess = sdma_go_disk::construct(file_, bytes);
    nodeaddress::ptr serv = config_->get_my_analysis_node(id_.task_);
    SSTMAC_DEBUG << "sdma_disk_lib: delivering to " << serv->to_string() << "\n";
    mess->toaddr_ = serv;
    mess->set_lib_name(sdma_disk_server::get_server_name());
    mess->set_needs_ack(false);

    os_->execute_kernel(AMI::AMI_COMM, AMI::AMI_COMM_SEND, mess);
  }

}
