#ifndef SDMA_LIB_H_
#define SDMA_LIB_H_

#include <sstmac/software/libraries/library.h>
#include "sdma_analysis_node_config.h"

namespace sdma
{

  class sdma_lib : public sstmac::sw::library
  {
  protected:
    static sstmac::debug dbg_;

    sstmac::sw::softwareid id_;

    sdma_lib(sstmac::sw::softwareid id) : id_(id)
    {
      libname_ = "sdma_lib-" + id.to_string();
      if (!dbg_.is_real())
        {
          dbg_ = sstmac::debug("<debug> sdma | sdma_lib");
          sstmac::logger::register_logger(&dbg_);
        }
    }

  public:
    typedef boost::intrusive_ptr<sdma_lib> ptr;

    virtual void
    process_data(long bytes) = 0;

    virtual void
    init_sdma(int stages, double conc);

    static sdma_analysis_node_config::ptr config_;

  };

}
#endif
