#include "sdma_staged_lib.h"
#include "sdma_message.h"
#include "sdma_staged_server.h"


using namespace sstmac;
using namespace sstmac::sw;

namespace sdma
{

  void
  sdma_staged_lib::process_data(long bytes)
  {
    sdma_go_staged::ptr mess = sdma_go_staged::construct(bytes);

    nodeaddress::ptr serv = config_->get_my_analysis_node(id_.task_);
    SSTMAC_DEBUG << "sdma_staged_lib: delivering to " << serv->to_string()
          << "\n";
    mess->toaddr_ = serv;
    mess->set_lib_name(sdma_staged_server::get_server_name());
    mess->set_needs_ack(false);

    os_->execute_kernel(AMI::AMI_COMM, AMI::AMI_COMM_SEND, mess);

  }

}
