#include "sdma_work_lib.h"

using namespace sstmac;
using namespace sstmac::sw;

namespace sdma
{

  debug sdma_work_lib::dbg_;

  void
  sdma_work_lib::mem_access(long bytes)
  {
    nodeaddress::ptr me = os_->get_my_addr();
    SSTMAC_DEBUG << "sdma_work_lib[" << me->to_string()
          << "] -- doing an memory access on " << bytes << " bytes \n";

    eventdata::ptr inst = eventdata::construct(get_lib_name(), timestamp(0));
    doing_memory_ = true;
    lib_compute_memmove::compute_block_access(bytes);

  }

  void
  sdma_work_lib::compute(long bytes)
  {
    nodeaddress::ptr me = os_->get_my_addr();
    SSTMAC_DEBUG << "sdma_work_lib[" << me->to_string()
          << "] -- doing an analysis on " << bytes << " bytes \n";

    eventdata::ptr inst = eventdata::construct(get_lib_name(), timestamp(0));
    doing_memory_ = false;

    //obviously, this is an arbitrary amount of work, 4 * bytes "flops"
    inst->set_event(INST_FLOP_LABEL, bytes * 4);

    lib_compute_inst::compute_inst(inst);
  }

}
